/*
* Автор: Маркелов С.В.
* Дата: 2014-07-15
* Задача: http://jira.softage.ru/jira/browse/SDFO-332
* Назначение: MESSAGES_VERSIONS.BEGINDATE должен быть not null
* Изменяются объекты:
		alter table MESSAGES_VERSIONS
*/

/*
  ****** Инструкции для SQLPlus (обязательно) ******
  Для печати сообщений:
  DBMS_OUTPUT.put_line('<Message>');
*/
whenever sqlerror exit 1;
set serveroutput on;
set echo off;

declare
	filename      varchar2(256) := 'sfm.database-update.2014-07-15.FixMESSAGES_VERSIONSColumns.sql';
	purpose       varchar2(4000) := 'MESSAGES_VERSIONS.BEGINDATE должен быть not null';
	script_exists number := 0;
    mindate       date;
begin

	--delete from DB_Update_History where script_name = filename;	commit;
	select count(*)
		into script_exists
		from DB_Update_History
	 where script_name = filename;

	if (script_exists > 0) then
		RAISE_APPLICATION_ERROR(-20001, '"' || filename || '" уже присутствует в базе');
	else
		insert into DB_Update_History
			(script_name, purpose)
		values
			(filename, purpose);
	end if;

	select min(BEGINDATE)
	into mindate
	from MESSAGES_VERSIONS
	where BEGINDATE is not null;

	update MESSAGES_VERSIONS
	set BEGINDATE = mindate
	where BEGINDATE is null;

	commit;

exception
	when others then
		rollback;
		raise;
end;

/

	alter table MESSAGES_VERSIONS modify (BEGINDATE date not null);

	/*
	****** Begin update script ******
	*/
		-- Не транзакционный апдейт
		-- Необходимы свои транзакции, если требуются
	/*
	****** End update script ******
	*/
